VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmServer 
   Caption         =   "JZ server"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstRazeni 
      Height          =   1035
      Left            =   840
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   1440
      Visible         =   0   'False
      Width           =   975
   End
   Begin MSWinsockLib.Winsock WS 
      Left            =   4200
      Top             =   1080
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label lblStav 
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "frmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'HTTP port
Private HTTPport As String
'Soubor s JZ
Private DataFile As String
'Vzdlen klient
Private ClientIP As String

Private Sub Form_Load()
    'Naten daj z parametr
    If Command = "" Then
        'Bez param.
        HTTPport = "80"
        If Len(App.Path) = 3 Then
            DataFile = App.Path & "data.xml"
        Else
            DataFile = App.Path & "\data.xml"
        End If
    Else
        'Parametry zadny
        Dim Param() As String
        Param() = Split(Command, " ")
        'Prvn port, pak soubor
        HTTPport = Param(0)
        DataFile = Param(1)
    End If
    
    'Zmnn stavu
    lblStav.Caption = "Server b na portu " & HTTPport & " s datovm souborem " & DataFile
    
    'Winsock
    With WS
        .LocalPort = HTTPport
        .Listen
    End With
End Sub

Private Sub WS_ConnectionRequest(ByVal requestID As Long)
    'Poadavek o spojen potvrdme
    WS.Close
    WS.Accept requestID
End Sub

Private Sub AllStations()
    'Nate do pole vechny stanice
    Dim Parser As New DOMDocument
    Dim XML As IXMLDOMNodeList
    
    'Naten JZ
    Parser.Load DataFile
    Set XML = Parser.selectNodes("//Stanice")
    
    Dim Stanice() As String
    ReDim Stanice(XML.length - 1)
    
    'Naplnn do promn
    Dim i As Long
    For i = 0 To XML.length - 1
        Stanice(i) = XML.Item(i).Text
    Next i
    
    'Promn pro pepis, kde bude kad stanice ji jen jednou
    Dim UStanice() As String
    ReDim UStanice(UBound(Stanice))
    
    Dim j As Long
    For i = 0 To UBound(Stanice)
        'Hledn, zda ji neexistuje
        For j = 0 To i
            If Stanice(i) = UStanice(j) Then GoTo KC
        Next j
        'Stanice jet nen zapsna --> zape se
        UStanice(i) = Stanice(i)
    
KC:
    Next i
    
    
    'Te jsou v UStanice vechny stanice (kad jen jednou) a poppad nkolik
    'przdnch mst, nsleduje seazen podle abecedy
    
    'Nacpou se tedy do listboxu a na nm se zapne azen
    For i = 0 To UBound(UStanice)
        If UStanice(i) <> "" Then lstRazeni.AddItem UStanice(i)
    Next i
    
    
    'Pepsn do promn SOutput (obsahuje u elementy)
    Dim SOutput() As String
    ReDim SOutput(lstRazeni.ListCount - 1)
    For i = 0 To lstRazeni.ListCount - 1
        SOutput(i) = "<Stanice>" & lstRazeni.List(i) & "</Stanice>"
    Next i
    
    'Te u sta odeslat winsockem
    If WS.State = sckConnected Then WS.Close
    With WS
        .RemoteHost = ClientIP
        .Connect
    End With
    
    Do Until WS.State = sckConnected
        DoEvents: DoEvents: DoEvents
    Loop
    
    'Zasln hlaviky
    WS.SendData "HTTP/1.0 200 OK" & vbCrLf
    WS.SendData "Content-type: text/xml" & vbCrLf & vbCrLf
    
    'Zasln hlaviky XML
    WS.SendData "<SeznamStanic>" & vbCrLf
    'Zapsn stanic
    For i = 0 To UBound(SOutput)
        WS.SendData SOutput(i) & vbCrLf
    Next i
    
    'Zapsn konce
    WS.SendData "</SeznamStanic>"
    
    'Odpojen
    WS.Close
    WS.Listen
    
End Sub

Private Sub WS_DataArrival(ByVal bytesTotal As Long)
    'Pijmut dat
    ClientIP = WS.RemoteHostIP
    Dim WData As String
    WS.GetData WData
    
    'Kontrola na seznam zastvek
    If Left(WData, 26) = "GET /SeznamStanic HTTP/1.0" Or Left(WData, 26) = "GET /SeznamStanic HTTP/1.1" Then
        'M se zaslat seznam zastvek
        AllStations
    End If
End Sub
